#include "haut_niv.h"

/* renvoie la position courante en cas de succes sinon -1
   affiche les erreurs renvoyer par les fonctions de bas niveau*/
pos_t lseek_minifs (desc_t descripteur, pos_t position, int mode)
{
  short delta;
  DESC *pdesc;
  stat_p pstat;
  short new_cur_pos;
  short new_cur_bloc;
  short nbre_bloc;
  short depassement,vidage;
  void *buf_vide;
  pos_t new_pos_in_file;
  n_bloc_s num_bloc;
  n_noeud_s num_node;
  noeud_p np;

  pdesc = desc_table + descripteur;
  pstat = pdesc->stat;	
  /*verification du type de fichier*/
  if(pstat->type != FIC)
    {
      perror("Type incorrect");
      return -1;
    }
  /* Nombre de bocs dans le fichier */
  nbre_bloc = pstat->taille / TAILLE_BLOC;
  if(pstat->taille % TAILLE_BLOC != 0)
    {
      nbre_bloc++;
    }
  /* calcule dans quel bloc on veut aller*/
  switch(mode)
    {
    case DEBUT:
      delta = 0;
      break;
    case COURANT:
      delta = ((pdesc->cur_bloc)* TAILLE_BLOC) + pdesc->cur_pos;
      break;
    case FIN:
      delta = pstat->taille;
      break;
    default:
      perror("mode incorecte");
      return -1;
    }
  new_pos_in_file = delta + position;
  depassement = new_pos_in_file - pstat->taille;
  if (((pdesc->mode) & M_ECR) != M_ECR  &&  depassement > 0)
    {
      new_pos_in_file = pstat->taille - 1;
      depassement = -1;
    }
  if (depassement < 0) /* on se deplace dans le fichier */
    {
      new_cur_pos = new_pos_in_file % TAILLE_BLOC;
      new_cur_bloc = new_pos_in_file / TAILLE_BLOC;
      /* changement du bloc et modification de cur_pos et cur_bloc*/
      if(new_cur_bloc != pdesc->cur_bloc)
	{
	  if(change_buf(descripteur, new_cur_bloc) == -1)
	    {
	      if (num_err == DESCRIPTEUR_INCONNU)
		perror("descripteur inconnue");
	      else
		perror("Erreur inconnue");
	      return -1;
	    }
	  pdesc->cur_bloc = new_cur_bloc;
	}
      pdesc->cur_pos = new_cur_pos;
      return new_pos_in_file;
    }
  else
    { /* On depasse la fin du fichier */
      /* On peut se dplasser au-dela de la fin du fichier
	 Les octets au-dela de la fin du fichier sont mis a zero */
      buf_vide = calloc(TAILLE_BLOC,1);
      if (nbre_bloc != 0)
	{/* Le fichier n'est pas vide */
	  /* On se positionne sur l'octet suivant le dernier octet du fichier */
	  new_cur_pos = (pstat->taille - 1) % TAILLE_BLOC;
	  new_cur_bloc = (pstat->taille - 1) / TAILLE_BLOC;
	  if(new_cur_bloc != pdesc->cur_bloc)
	    {
	      if(change_buf(descripteur, new_cur_bloc) == -1)
		{
		  if (num_err == DESCRIPTEUR_INCONNU)
		    perror("descripteur inconue");
		  else
		    perror("Erreur inconnue");
		  free(buf_vide);
		  return -1;
		}
	      pdesc->cur_bloc = new_cur_bloc;
	    }
	  pdesc->cur_pos = new_cur_pos + 1;
	  if (depassement == 0)
	    {
	      free(buf_vide);
	      return (pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc);
	    }
	  /* On remplit le dernier bloc du fichier */
	  if(TAILLE_BLOC-pdesc->cur_pos < depassement)
	    vidage = TAILLE_BLOC - pdesc->cur_pos;
	  else
	    vidage = depassement; 
	  if (memcpy(pdesc->buffer+pdesc->cur_pos, buf_vide, vidage) == NULL)
	    {
	      perror("memcpy");
	      free(buf_vide);
	      return -1;
	    }
	  depassement-=vidage;
	  pdesc->cur_pos+=vidage;
	  pstat->taille = pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc;
	}
      else
	{/* Le fichier est vide */
	  pdesc->cur_bloc --;
	}
      /* On ajoute de nouveaux blocs au fichier */
      num_node.num = pdesc->node;
      num_node.dev = pdesc->dev;
      np = malloc(sizeof(entrep_s));
      while(depassement > 0)
	{
	  pdesc->cur_pos = 0;
	  num_bloc = new_bloc(pdesc->dev);
	  if(num_bloc.num == -1)
	    { 
	      switch(num_err)
		{
		case ERREUR_INCONNUE:
		  perror("erreur inconue");
		  break;
		case PLUS_DE_BLOC_LIBRE:
		  perror("plus de bloc libre");
		  break;
		default:
		  perror("erreur inatendue");
		  break;
		}
	      free(np);
	      free(buf_vide);
	      return -1;
	    }	
	  if(add_bloc_in_node(num_node, num_bloc.num, pstat->taille) == -1)
	    {
	      free(np);
	      free(buf_vide);
	      return -1;
	    }		
	  if(change_buf(descripteur,pdesc->cur_bloc+1) == -1)
	    {
	      if (num_err == DESCRIPTEUR_INCONNU)
		perror("descripteur inconue");
	      else if (num_err == MAUVAISE_POSITION)
		perror("Incoherence entre le pointeur de bloc et la taille du fichier");
	      else
		perror("Erreur inconnue");
	      free(np);
	      free(buf_vide);
	      return -1;
	    }
	  pdesc->cur_bloc ++;
	  if(depassement / TAILLE_BLOC  ==  0)
	    vidage = depassement;
	  else
	    vidage = TAILLE_BLOC;
	  if (memcpy(pdesc->buffer,buf_vide,vidage) == NULL)
	    {
	      perror("memcpy");
	      free(buf_vide);
	      free(np);
	      return -1;
	    }
	  pdesc->cur_pos = vidage;
	  depassement-=vidage;
	  pstat->taille = pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc;
	  if (read_node(np,num_node) == -1) {
	    free(np);
	    free(buf_vide);
	    return -1;
	  }
	  np->taille = pstat->taille;
	  if (write_node(np,num_node) == -1) {
	    free(np);
	    free(buf_vide);
	    return -1;
	  }
	  // Ecrire la nouvelle taille su rle disque
	}
      free(np);
      free(buf_vide);
      return (pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc);
    }
}

int rmdir_minifs(char *reference)
{
  n_noeud_s struct_node;
  n_noeud_s struct_node_pere;
  n_bloc_s num_bloc;
  noeud_p np;
  noeud_p np_pere;
  int i;
  DESC *pdesc;
  stat_p pstat;
  entrep_p e;
  char *rep_pere;
  char *rep;
  int taille_ref;
	
  struct_node = find_ref(reference);
  if(struct_node.num == -1)
    {
      perror("repertoire non existant");
      return -1;
    }
  np = (noeud_p) malloc (sizeof(noeud_s));
  if(read_node(np, struct_node) == -1)
    {
      perror("erreur inconue");
      free(np);
      return -1;
    }
  if(np->type != REP)
    {
      fprintf(stderr,"rmdir_minifs : %s est un fichier!!", reference);
      free(np);
      return -1;
    }
  /* si la reference est  une racine de disque deja monte*/
  if(struct_node.num == ROOT_NODE)
    {
      perror("Utiliser unmount pour supprimer les disque montes.");
      free(np);
      return -1;
    }
  /* si le repertoire est non vide*/
  if((np->taille/sizeof(entrep_s)) != 2)
    {
      perror("erreur : repertoire non vide");
      free(np);
      return -1;
    }
  /* si le repertoire est ouvert*/	
  for(i=0;i<MAX_OPEN_FILE; i++)
    {
      pdesc = desc_table + i;
      if((pdesc->desc != DESC_LIBRE) &&
	 (pdesc->node == struct_node.num) && 
	 (pdesc->dev == struct_node.dev))
	{	
	  perror("ferme le repertoire avant suppression");
	  free(np);
	  return -1;
	}
    }
  /*on decremente le nbre de liens de 2 ("." et le repertoire pere)*/
  np->liens -= 2;
  if (write_node(np,struct_node) == -1)
    {
      perror("erreur inconue");
      free(np);
      return -1;
    }
  /*suppression du noeud*/
  if(supp_node(struct_node)== -1)
    {
      if(num_err == RESTE_DES_LIENS)
	perror("reste des liens");
      else
	perror("erreur inconue");
      np->liens +=2;
      write_node(np,struct_node);
      free(np);
      return -1;
    }
  /*trouver le repertoire pere */
  taille_ref = strlen(reference);
  while(taille_ref>0)
    {
      if (reference[taille_ref-1] == '/')
	break;
      taille_ref--;
    }
  if(taille_ref == 1)
    {
      rep_pere = "/";
    }
  else if(taille_ref == 0)
    {
      rep_pere = ".";
    }
  else
    {
      rep_pere = (char *) malloc(taille_ref);
      strncpy(rep_pere, reference, taille_ref);
      rep_pere[taille_ref-1] = '\0';
    }
  rep = reference + taille_ref;
  if(strlen(rep) > 29)
    {	
      fprintf(stderr,"rmdir : %s nom de repertoire trop long",reference);
      np->liens+=2;
      write_node(np,struct_node);
      free(np);
      if(taille_ref>1)
	free(rep_pere);
      return -1;
    }
  struct_node_pere = find_ref(rep_pere);
  if(struct_node_pere.num == -1)
    {
      perror("repertoire pere non existant");
      np->liens+=2;
      write_node(np,struct_node);
      free(np);
      free(rep_pere);
      return -1;
    }
  /*recherche de l'entree et sa suppression*/ 
  e = (entrep_p) malloc(sizeof(entrep_s));
  e->numero = struct_node.num;
  strcpy(e->nom, rep);
  if((np_pere = supp_entry(struct_node_pere,e)) == NULL)
    {
      if(num_err == ERREUR_INCONNUE)
	perror("erreur inconue");
      else if(num_err == ENTREE_REPERTOIRE_INCONNUE)
	perror("erreur entree repertoire inconue");
      else
	perror("type incorrecte");
      np->liens+=2;
      write_node(np, struct_node);
      free(np);
      free(rep_pere);
      free(e);
      return -1;
    }	
  np_pere->liens--;
  if (write_node(np_pere,struct_node_pere) == -1) {
      free(np);
      free(rep_pere);
      free(e);
      return -1;
    }	
  pdesc = desc_table + desc_cur_dir;
  if(struct_node_pere.num == pdesc->node && struct_node_pere.dev == pdesc->dev)
    {
      num_bloc = num_of_bloc_i(pdesc->cur_bloc,struct_node_pere);
      if(read_bloc(pdesc->buffer,num_bloc) == -1)
	{
	  perror("erreur inconue");
	  np->liens+=2;
	  np_pere->liens++;
	  write_node(np, struct_node);
	  new_entry(struct_node_pere, e);
	  free(np);
	  free(rep_pere);
	  free(e);
	  return -1;
	}
      pstat = pdesc->stat;
      pstat->liens = np_pere->liens;
      pstat->taille = np_pere->taille;
    }	
	
  free(np);
  free(rep_pere);
  free(e);
  return 0;
}

int close_minifs(desc_t descripteur)
{
	stat_p pstat;
	DESC *pdesc;
	noeud_p node;
	n_bloc_s num_bloc;
	n_noeud_s num_node;
	pdesc = desc_table + descripteur;
	pstat = pdesc->stat;
	
	num_node.num = pdesc->node;
	num_node.dev = pdesc->dev;
	/*si le mode est different de lecture en sauvegarde le buffer*/
	if((pdesc->mode & M_ECR) == M_ECR  &&  pstat->taille != 0)
	{
		num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node);
		if (num_bloc.num == -1) 
		{
			if(num_err == ERREUR_INCONNUE)
				perror("erreur inconue");
			else
				perror("mauvaise position"); 
			return -1;
			
		}
		if (write_bloc(pdesc->buffer,num_bloc) == -1) 
		{
			perror("erreur inconue");
			return -1;
		}
	}
	/*mettre a jour le noeud*/
	node = (noeud_p) malloc(sizeof(noeud_s));
	if(read_node(node, num_node) == -1)
	{
		perror("erreur inconue");
		free(node);
		return -1;
	}
	node->etat = pstat->etat;
	node->type = pstat->type;
	node->taille = pstat->taille;
	node->liens = pstat->liens;
	if(write_node(node,num_node) == -1)
	{
		perror("erreur inconnue");
		free(node);
		return -1;
	}
	/*liberer le descripteur*/
	free(pdesc->buffer);
	free(pdesc->stat);
	pdesc->desc = DESC_LIBRE;
	free(node);
	return 0;
}/*fin de la fonction close*/

/* renvoie la position courante en cas de succes sinon -1
affiche les erreurs renvoyer par les fonctions de bas niveau*/
int read_minifs(desc_t descripteur, void *tampon, int taille)
{
  n_noeud_s num_node;
  DESC *pdesc;
  stat_p pstat;
  void *buf_tampon;
  short old_pos,old_bloc;
  int reste,lecture;

  pdesc = desc_table + descripteur;
  pstat = pdesc->stat;
  /* Verification du mode d'ouverture */
  if((pdesc->mode & M_LEC) != M_LEC) /* Fichier ouvert en ecriture seule */
    {
      perror("Le fichier est ouvert en ecriture seule");
      return -1;
    }
  num_node.num = pdesc->node;
  num_node.dev = pdesc->dev;
  /* read_minifs ne fonctionne que sur les fichiers */
  if(pstat->type != FIC) 
    {
      perror("erreur verifier le type");
      return -1;
    }
  /* Verification qu'on ne depasse pas la fin du fichier */
  if (taille > pstat->taille - (pdesc->cur_pos+pdesc->cur_bloc*TAILLE_BLOC))
    taille =  pstat->taille - (pdesc->cur_pos+pdesc->cur_bloc*TAILLE_BLOC);
  reste = taille;
  if (reste <= 0) 
    return 0;
  old_pos = pdesc->cur_pos;
  old_bloc = pdesc->cur_bloc;
  buf_tampon = tampon;
  if (reste < TAILLE_BLOC - pdesc->cur_pos)
    lecture = reste;
  else
    lecture = TAILLE_BLOC - pdesc->cur_pos;
  if (memcpy(buf_tampon, pdesc->buffer, lecture) == NULL) 
    {
      perror("memcpy");
      return -1;
    }
  reste -= lecture;
  pdesc->cur_pos += lecture;
  buf_tampon += lecture;
  while(reste > 0)
    {
      if(change_buf(descripteur, pdesc->cur_bloc+1) == -1)
	{
	  perror("descripteur inconnue");
	  pdesc->cur_pos = old_pos;
	  change_buf(descripteur, old_bloc);
	  pdesc->cur_bloc = old_bloc;
	  return -1;
	}
      pdesc->cur_pos = 0;
      pdesc->cur_bloc++;
      if (reste / TAILLE_BLOC == 0)
	lecture = reste;
      else
	lecture = TAILLE_BLOC;
      if (memcpy(buf_tampon, pdesc->buffer, lecture) == NULL) 
	{
	  perror("memcpy");
	  pdesc->cur_pos = old_pos;
	  change_buf(descripteur, old_bloc);
	  pdesc->cur_bloc = old_bloc;
	  return -1;
	}
      reste -= lecture;
      pdesc->cur_pos += lecture;
      buf_tampon += lecture;
    }

  return taille;
}/*fin de la fonction read*/

entrep_p readdir_minifs(desc_t descripteur)
{
	entrep_p result;
	DESC *pdesc;
	stat_p pstat;

	pdesc = desc_table+descripteur;
	pstat = pdesc->stat;
	if((pdesc->cur_bloc * TAILLE_BLOC + pdesc->cur_pos) >= pstat->taille) {
	        return NULL;
	}
	if(pdesc->cur_pos == TAILLE_BLOC)
        {
		if(change_buf(descripteur,pdesc->cur_bloc+1) == -1)
		{
		    perror("descripteur inconue");
		    return NULL;
		}
		pdesc->cur_bloc ++;
		pdesc->cur_pos = 0;
	}
	result = (entrep_p) malloc(sizeof(entrep_s));
	*result = *((entrep_p)pdesc->buffer+(pdesc->cur_pos/sizeof(entrep_s)));
	pdesc->cur_pos+=(sizeof(entrep_s));
	return result;
}/*fin de la fonction readdir*/

int rewinddir_minifs(desc_t descripteur)
{
	DESC *pdesc;
	stat_p pstat;
	
	pdesc = desc_table + descripteur;
	pstat = pdesc->stat;
	if(pstat->type != REP)
	{
		perror("erreur : pas un Repertoire");
		return -1;
	}
	if(change_buf(descripteur, 0) == -1)
	{
	 	switch(num_err)
			{
			case DESCRIPTEUR_INCONNU:
				perror("erreur: descripteur inconu");
				break;
			case ERREUR_INCONNUE:
				perror("erreur inconnu");
				break;
			case MAUVAISE_POSITION:
				perror("mauvaise position");
				break;
			default:
				perror("erreur innatendu");
			}
			return -1;
	}
	pdesc->cur_bloc = 0;
	pdesc->cur_pos = 0;
	return 0;
}

int mkdir_minifs(char *reference)
{
  n_noeud_s num_node;
  n_noeud_s num_node_pere;
  char *rep_pere;
  char *rep;
  noeud_p np;
  noeud_p np_pere;
  n_bloc_s num_bloc;
  DESC *pdesc;
  stat_p pstat;
  entrep_p e;
  int taille_ref;

  num_node = find_ref(reference);
  if(num_node.num != -1)
    { 
      fprintf(stderr,"Le repertoire a creer %s existe deja\n",reference);
      return -1;
    }
  else 
    {
      switch (num_err) {
      case ENTREE_REPERTOIRE_INCONNUE:
	break;
      case CHEMIN_INCORRECT:
	fprintf(stderr,"Le chemin %s est incorrect\n",reference);
	return -1;
      default:
	fprintf(stderr,"Erreur inconnue\n");
	return -1;
      }
    }
  np = (noeud_p) malloc(sizeof(noeud_s));
  if (strcmp(reference,"/") == 0) 
    {
      fprintf(stderr,"Impossible de creer le rep '/'\n");
      free(np);
      return -1;
    }
  taille_ref = strlen(reference) - 1;
  while(taille_ref>0)
    {
      if (reference[taille_ref-1] == '/')
	break;
      taille_ref--;
    }
  /*on recupere le nom du rep dans lequel on veux creer le nouveau rep */
  if(taille_ref == 1)
    {
      rep_pere = "/";
    }
  else if(taille_ref == 0)
    {
      rep_pere = ".";
    }
  else
    {
      rep_pere = (char *) malloc(taille_ref);
      strncpy(rep_pere, reference, taille_ref);
      rep_pere[taille_ref-1] = '\0';
    }
  rep = reference + taille_ref;
  if(strlen(rep) > 29)
    {	
      fprintf(stderr,"mkdir : %s nom de repertoire tres long",reference);
      free(np);
      if(taille_ref>1)
	free(rep_pere);
      return -1;
    }       
  /* Modification du rep pere */
  num_node_pere = find_ref(rep_pere);
  if(num_node_pere.num == -1)
    {
      switch (num_err) {
      case ENTREE_REPERTOIRE_INCONNUE:
	fprintf(stderr,"Le repertoire %s n'existe pas\n",reference);
	break;
      case CHEMIN_INCORRECT:
	fprintf(stderr,"Le chemin %s est incorrect\n",reference);
	break;
      default:
	fprintf(stderr,"Erreur inconnue\n");
      }
      free(np);
      free(rep_pere);
      return -1;
    }
  /* Recherche d'un noeud libre pour y stocker le nouveau rep */
  num_node = new_node(num_node_pere.dev);
  if(num_node.num == -1)
    {
      free(np);
      free(rep_pere);
      return -1;
    }
  e = (entrep_p) malloc(sizeof(entrep_s));
  strcpy(e->nom, rep);
  e->numero = num_node.num;
  /* Ajout du nouveau rep dans le rep pere */	
  if((np_pere = new_entry(num_node_pere, e)) == NULL)
    {
      if(num_err == ERREUR_INCONNUE)
	perror("erreur inconue");
      else if(num_err == ENTREE_EXISTANTE)
	perror("entree existant deja");
      else if(num_err == PLUS_DE_BLOC_LIBRE)
	perror("plus de bloc libre");
      else
	perror("type incorrecte");
      supp_node(num_node);
      free(e);
      free(np);
      free(rep_pere);
      return -1; 
    }	
  np_pere->liens++;
  if(write_node(np_pere,num_node_pere) == -1)
    {
      np_pere = supp_entry(num_node_pere, e);
      free(e);
      np_pere->liens--;
      if(num_node_pere.num == pdesc->node && num_node_pere.dev == pdesc->dev)
	{
	  num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node_pere);
	  if(read_bloc(pdesc->buffer,num_bloc) == -1)
	    {
	      perror("erreur inconue");
	      np_pere->liens--;			
	      supp_node(num_node);
	      free(np);
	      free(rep_pere);
	      free(e);
	      return -1;
	    }
	  pstat = pdesc->stat;
	  pstat->liens = np_pere->liens;
	  pstat->taille = np_pere->taille;
			
	}
      supp_node(num_node);
      free(e);
      free(np);
      free(rep_pere);
      return -1;
    }
  /* On regarde si le rep pere est le rep courant auquel cas on met le desc
     de celui-ci a jour */
  pdesc = desc_table + desc_cur_dir;
  if(num_node_pere.num == pdesc->node && num_node_pere.dev == pdesc->dev)
    { 
      num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node_pere);
      if(read_bloc(pdesc->buffer,num_bloc) == -1)
	{
	  perror("erreur inconue");
	  np_pere->liens--;			
	  supp_node(num_node);
	  free(np);
	  free(rep_pere);
	  free(e);
	  return -1;
	}
      pstat = pdesc->stat;
      pstat->liens = np_pere->liens;
      pstat->taille = np_pere->taille;
    }
  /*creation du repertoire*/
  /* Initialisation du noeud trouve */
  np->etat = NOEUD_UTILISE;
  np->type = REP;
  np->taille = 0;
  np->liens = 1;
  if(write_node(np,num_node) == -1)
    {
      np_pere = supp_entry(num_node_pere, e);
      free(e);
      np_pere->liens--;
      if(num_node_pere.num == pdesc->node && num_node_pere.dev == pdesc->dev)
	{
	  num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node_pere);
	  if(read_bloc(pdesc->buffer,num_bloc) == -1)
	    {
	      perror("erreur inconue");
	      np_pere->liens--;			
	      supp_node(num_node);
	      free(np);
	      free(rep_pere);
	      free(e);
	      return -1;
	    }
	  pstat = pdesc->stat;
	  pstat->liens = np_pere->liens;
	  pstat->taille = np_pere->taille;
			
	}
      supp_node(num_node);
      free(e);
      free(np);
      free(rep_pere);
      return -1;
    }
  /* Ajout de l'entree '.' dans le rep */
  strcpy(e->nom, ".");
  free(np);
  if((np=new_entry(num_node,e)) == NULL)
    {
      if(num_err == ERREUR_INCONNUE)
	perror("erreur inconue");
      else if(num_err == ENTREE_EXISTANTE)
	perror("entree existant deja");
      else if(num_err == PLUS_DE_BLOC_LIBRE)
	perror("plus de bloc libre");
      else
	perror("type incorrecte");
      np_pere = supp_entry(num_node_pere, e);
      supp_node(num_node);
      free(e);
      np_pere->liens--;
      if(num_node_pere.num == pdesc->node && num_node_pere.dev == pdesc->dev)
	{
	  num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node_pere);
	  if(read_bloc(pdesc->buffer,num_bloc) == -1)
	    {
	      perror("erreur inconue");
	      np_pere->liens--;			
	      free(np);
	      free(rep_pere);
	      free(e);
	      return -1;
	    }
	  pstat = pdesc->stat;
	  pstat->liens = np_pere->liens;
	  pstat->taille = np_pere->taille;
	}
      free(e);
      free(np);
      free(rep_pere); 
      return -1; 
    }
  np->liens ++;
  if(write_node(np,num_node) == -1)
    {
      np_pere = supp_entry(num_node_pere, e);
      supp_node(num_node);
      free(e);
      np_pere->liens--;
      if(num_node_pere.num == pdesc->node && num_node_pere.dev == pdesc->dev)
	{
	  num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node_pere);
	  if(read_bloc(pdesc->buffer,num_bloc) == -1)
	    {
	      perror("erreur inconue");
	      np_pere->liens--;			
	      free(np);
	      free(rep_pere);
	      free(e);
	      return -1;
	    }
	  pstat = pdesc->stat;
	  pstat->liens = np_pere->liens;
	  pstat->taille = np_pere->taille;
			
	}
      free(e);
      free(np);
      free(rep_pere);
      return -1;
    }
  /* Ajout de l'entree '..' dans le rep */
  strcpy(e->nom, "..");
  e->numero = num_node_pere.num;
  if(new_entry(num_node,e) == NULL)
    {
      if(num_err == ERREUR_INCONNUE)
	perror("erreur inconue");
      else if(num_err == ENTREE_EXISTANTE)
	perror("entree inxistant");
      else if(num_err == PLUS_DE_BLOC_LIBRE)
	perror("plus de bloc libre");
      else
	perror("type incorrecte");
      num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node_pere);
      if(read_bloc(pdesc->buffer,num_bloc) == -1)
	{
	  perror("erreur inconue");
	  np_pere->liens--;			
	  free(np);
	  free(rep_pere);
	  free(e);
	  return -1;
	}
      pstat = pdesc->stat;
      pstat->liens = np_pere->liens;
      pstat->taille = np_pere->taille;
      return -1; 
    }

  free(np);
  free(np_pere);
  if(taille_ref>1)
    free(rep_pere);
  free(e);
  return 0;
}/*fin de la fonction mkdir*/

int write_minifs(desc_t descripteur, void *tampon, int taille)
{
  n_noeud_s num_node;
  DESC *pdesc;
  stat_p pstat;
  int nbre_bloc,reste;
  n_bloc_s num_bloc;
  short pas_encore_lu;
  void *buf_p;
  noeud_p np;

  pdesc = desc_table + descripteur;
  pstat = pdesc->stat;
  if (pstat->type != FIC)
    {
      perror("Le fichier est ouvert en lecture seule");
      return -1;
    }
  nbre_bloc = pstat->taille / TAILLE_BLOC;
  if (pstat->taille % TAILLE_BLOC != 0)
    nbre_bloc ++;
  pas_encore_lu = taille;
  buf_p = tampon;
  if (nbre_bloc > 0)
    {
      if(TAILLE_BLOC-pdesc->cur_pos < pas_encore_lu)
	reste = TAILLE_BLOC - pdesc->cur_pos;
      else
	reste = pas_encore_lu; 
      if (memcpy(pdesc->buffer+pdesc->cur_pos, buf_p, reste) == NULL)
	{
	  perror("memcpy");
	  return -1;
	}
      pas_encore_lu-=reste;
      pdesc->cur_pos+=reste;
      buf_p += reste;
      if (pstat->taille < (pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc))
	pstat->taille = pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc;
    }
  else 
    {
      pdesc->cur_bloc = -1;
    }
  num_node.num = pdesc->node;
  num_node.dev = pdesc->dev;
  while(pas_encore_lu > 0)
    {
      pdesc->cur_pos = 0;
      if(pdesc->cur_bloc+1 > nbre_bloc-1)
	{
	  num_bloc = new_bloc(pdesc->dev);
	  if(num_bloc.num == -1)
	    { 
	      switch(num_err)
		{
		case ERREUR_INCONNUE:
		  perror("erreur inconue");
		  break;
		case PLUS_DE_BLOC_LIBRE:
		  perror("plus de bloc libre");
		  break;
		default:
		  perror("erreur inatendue");
		  break;
		}
	      return -1;
	    }	
	  if(add_bloc_in_node(num_node, num_bloc.num, pstat->taille)==-1)
	    {
	      return -1;
	    }
	}
      if(change_buf(descripteur,pdesc->cur_bloc+1) == -1)
	{
	  perror("descripteur inconue");
	  return -1;
	}
      pdesc->cur_bloc ++;
      if(pas_encore_lu / TAILLE_BLOC  ==  0)
	reste = pas_encore_lu;
      else
	reste = TAILLE_BLOC;
      if (memcpy(pdesc->buffer,buf_p,reste) == NULL)
	{
	  perror("memcpy");
	  return -1;
	}
      buf_p+=reste;
      pdesc->cur_pos = reste;
      pas_encore_lu-=reste;
      /* Depasse-t-on la fin de fichier ? */
      if (pstat->taille < (pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc)) {
	/* On augmente la taille du fichier */
	pstat->taille = pdesc->cur_pos + TAILLE_BLOC*pdesc->cur_bloc;
	/* Ecriture de la taille sur le disque */
	np = malloc(sizeof(entrep_s));
	if (read_node(np,num_node) == -1) {
	  free(np);
	  return -1;
	}
	np->taille = pstat->taille;
	if (write_node(np,num_node) == -1) {
	  free(np);
	  return -1;
	} 
      }
    }
  return (int)buf_p-(int)tampon;
}/*fin de la fonction write_minifs*/

desc_t open_minifs(char *reference, int mode)
{
  n_noeud_s struct_node;
  n_noeud_s struct_node_libre;
  n_noeud_s struct_node_pere;
  int i, retour, rb, taille_ref;
  n_bloc_s numero_pr, num_bloc;
  noeud_p noeud;
  n_bloc_s num_i_bloc;
  int nbre_of_bloc;
  DESC *pdesc;
  stat_p pstat;
  noeud_p np;
  entrep_p entree;
  char *rep_pere, *fic;

  struct_node = find_ref(reference);	
  /* si le fichier existe */
  if(struct_node.num != -1)
    {
      noeud = (noeud_p) malloc(sizeof(noeud_s));
      retour = read_node(noeud,struct_node);
      if(retour == -1)
	{
	  perror("erreur inconue read_node");
	  free(noeud);
	  return -1;
	}
      for(i=0; i<MAX_OPEN_FILE; i++)
	{
	  pdesc = desc_table + i;
	  /* rechercher un descripteur libre*/
	  if(pdesc->desc == DESC_LIBRE)
	    {
	      /* remplissage de la structure stat*/
	      pdesc->stat = (stat_p) malloc(sizeof(struct status));
	      pstat = pdesc->stat;
	      pstat->etat = noeud->etat;
	      pstat->type = noeud->type;
	      pstat->taille = noeud->taille;
	      pstat->liens =  noeud->liens;
	      pdesc->mode = mode;
	      pdesc->node = struct_node.num;
	      pdesc->dev = struct_node.dev;
	      pdesc->cur_pos = 0;
	      pdesc->cur_bloc = 0;
	      numero_pr = num_of_bloc_i(0, struct_node);
	      if(numero_pr.num == -1)
		{
		  perror("erreur a faire");
		  free(noeud);
		  free(pdesc->stat);
		  return -1;
		}
	      pdesc->buffer = malloc(TAILLE_BLOC);
	      rb = read_bloc(desc_table[i].buffer, numero_pr);
	      if(rb == -1)
		{
		  perror("erreur lecture bloc");
		  free(noeud);
		  free(pdesc->stat);
		  free(pdesc->buffer);
		  return -1;
		}
	      if(((mode & M_ZER) == M_ZER) && (noeud->type != REP))
		{
		  nbre_of_bloc = (noeud->taille)/TAILLE_BLOC;
		  if(noeud->taille%TAILLE_BLOC != 0)
		    nbre_of_bloc++;
		  for(i=0; i<nbre_of_bloc;i++)
		    {
		      num_i_bloc = num_of_bloc_i(i,struct_node);
		      if(num_i_bloc.num == -1)
			perror("Des blocs n'ont pas pu etre liberer\n");
		      else{
			if(supp_bloc(num_i_bloc) == -1)		
			  perror("Des blocs n'ont pas pu etre liberer\n");
		      }
		    }//fin de la boucle for
		  noeud->taille = 0;
		}/*fin du if M_ZER*/
	      pdesc->desc = i;
	      free(noeud);
	      return (desc_t)i;
	    }/*fin de if DESC_LIBRE*/
	}/*fin du for i=0..MAX_OPEN_FILES*/
      perror("Plus de descripteurs libres");
      free(noeud);
      free(pdesc->stat);
      return -1;
    }/*fin de if(struct_node...)*/
  else{/*2*/ /*Le fichier n'existe pas */
    /*creation du fichier*/
    if((mode & M_CRE) == M_CRE  &&  num_err == ENTREE_REPERTOIRE_INCONNUE)
      {/*3*/
	/* On separe le nom du nouveau fichier et celui de son rep pere */
	taille_ref = strlen(reference) - 1;
	while(taille_ref>=0)
	  {
	    if (reference[taille_ref] == '/')
	      break;
	    taille_ref--;
	  }
	if(taille_ref == 0)
	  {
	    rep_pere = "/";
	  }
	else if(taille_ref == -1)
	  {
	    rep_pere = ".";
	  }
	else
	  {
	    rep_pere = (char *) malloc(taille_ref+1);
	    strncpy(rep_pere, reference, taille_ref);
	    rep_pere[taille_ref] = '\0';
	  }
	fic = reference + taille_ref + 1;
	if(strlen(fic) <= 0 || strlen(fic) > 29)
	  {
	    if(strlen(fic) <= 0)
	      fprintf(stderr,"open_minifs : %s nom de fichier trop court",reference);
	    else
	      fprintf(stderr,"open_minifs : %s nom de fichier trop long",reference);
	    if(taille_ref>0)
	      free(rep_pere);
	    return -1;
	  }       
	/* Recherche du rep pere */
	struct_node_pere = find_ref(rep_pere);
	if (struct_node_pere.num == -1) {
	  fprintf(stderr,"%s n'est pas un chemin correct\n",rep_pere);
	  if (taille_ref > 0)
	    free(rep_pere);
	  return -1;
	}
	/*creation d'un nouveau noeud*/
	struct_node_libre = new_node (struct_node.dev);
	if(struct_node_libre.num == -1)
	  {
	    if(num_err == PLUS_DE_NOEUD_LIBRE)
	      {
		perror("Plus de noeud libre");
		return -1;
	      }
	    else
	      {
		perror("Erreur Inconue");
		return -1;
	      }
	  }
	/*initialisation du nouveau noeud*/
	noeud = (noeud_p) malloc(sizeof(noeud_s));
	noeud->etat = NOEUD_UTILISE;
	noeud->type = FIC;
	noeud->taille = 0;
	noeud->liens = 1;
	if (write_node(noeud,struct_node_libre) == -1) {
	  free(noeud);
	  if (taille_ref > 0)
	    free(rep_pere);
	  supp_node(struct_node_libre);
	  return -1;
	}
	/* Ajout du fichier dans le rep pere */
	entree = (entrep_p) malloc(sizeof(entrep_s));
	entree->numero = struct_node_libre.num;
	strcpy(entree->nom,fic);
	if ((np=new_entry(struct_node_pere,entree)) == NULL) {
	  fprintf(stderr,"Echec a la creation d'une nouvelle entree ds %s\n",rep_pere);
	  supp_node(struct_node_libre);
	  free(np);
	  free(noeud);
	  free(entree);
	  if (taille_ref > 0)
	    free(rep_pere);
	  return -1;
	}
	/* On regarde si le rep pere est le rep courant pour mettre son desc a jour */
	pdesc = desc_table + desc_cur_dir;
	if(struct_node_pere.num == pdesc->node && struct_node_pere.dev == pdesc->dev)
	  { 
	    num_bloc = num_of_bloc_i(pdesc->cur_bloc,struct_node_pere);
	    if(read_bloc(pdesc->buffer,num_bloc) == -1)
	      {
		perror("erreur inconue");
		supp_node(struct_node_pere);
		supp_entry(struct_node_pere,entree);
		free(np);
		free(noeud);
		if (taille_ref > 0)
		  free(rep_pere);
		free(entree);
		return -1;
	      }
	    pstat = pdesc->stat;
	    pstat->taille = np->taille;
	  }
	/* Recherche d'un desc libre pour ajouter le ficher a la table des desc */
	for(i=0; i<MAX_OPEN_FILE; i++)
	  {/*4*/
	    pdesc = desc_table+i;
	    if(pdesc->desc == DESC_LIBRE)
	      {/*5*/ /* On a trouve un desc libre */
		pdesc->stat = (stat_p) malloc(sizeof(struct status));
		pstat = pdesc->stat;
		pstat->etat = noeud->etat;
		pstat->type = noeud->type;
		pstat->taille = noeud->taille;
		pstat->liens =  noeud->liens;
		pdesc->dev = struct_node.dev;
		pdesc->mode = mode;
		pdesc->node = struct_node_libre.num;
		pdesc->cur_pos = 0;
		pdesc->cur_bloc = 0;
		pdesc->buffer = calloc(TAILLE_BLOC,1);
		pdesc->desc = i;
		return (desc_t)i;
	      }/*5*/
	  }/*4*/
	fprintf(stderr,"%s a ete cree mais il n'est pas possible de l'ouvrir.\n",reference);
	fprintf(stderr,"Plus de descripteur libre, fermez des fichiers\n");
	supp_node(struct_node_pere);
	np=supp_entry(struct_node_pere,entree);
	pdesc = desc_table + desc_cur_dir;
	if(struct_node_pere.num == pdesc->node && struct_node_pere.dev == pdesc->dev)
	  { 
	    num_bloc = num_of_bloc_i(pdesc->cur_bloc,struct_node_pere);
	    read_bloc(pdesc->buffer,num_bloc);
	    pstat = pdesc->stat;
	    pstat->taille = np->taille;
	  }
	free(noeud);
	free(entree);
	if (taille_ref > 0)
	  free(rep_pere);
	free(np);
	free(pdesc->stat);
	return -1;
      }/*3*/
    else
      {
	perror("Fichier inexistant");
	return -1;
      }
  }/*2*/
}//fin de la fonction

int stat_minifs(char *reference, stat_p buf)
{
  n_noeud_s n1;
  noeud_p np;
  int rn;
  n1 = find_ref(reference);
  if(n1.num == -1)
    {
      switch(num_err)
	{
	case ENTREE_REPERTOIRE_INCONNUE:
	  perror("entree repertoire inconnue");
	case TYPE_INCORRECT:
	  fprintf(stderr, "impossible de trouver %s, soit le fichier n'existe pas soit le chemin est incorrecte\n",reference); 
	case DISQUE_INCONNU:
	  fprintf(stderr,"erreur de disque monter");
	default:
	  perror("erreur inconnue");
	}
      free(np);
      return -1;
    }
  else
    {
      np = (noeud_p)malloc(sizeof(noeud_s));
      rn = read_node(np, n1);
      if(rn == -1)
	{
	  switch(num_err)
	    {
	    case MAUVAISE_POSITION:
	      fprintf(stderr,"Tentative d'ecriture hors de la zone de donnees\n");
	      break;
	    case DISQUE_INCONNU:
	      fprintf(stderr,"Tentative d'ecriture su run disque non valide\n");
	      break;
	    default: 
	      fprintf(stderr,"Erreur incconue read_node\n");
	    }
	  free(np);
	  return -1;
	}
      else
	{
	  buf->etat = np->etat;
	  buf->type = np->type;
	  buf->taille = np->taille;
	  buf->liens = np->liens;
	  return 0;
	}
    }
}

int fstat_minifs(desc_t descripteur, stat_p buf)
{
  stat_p pstat;
  DESC *pdesc;
	
  if(descripteur<0 || descripteur >= MAX_OPEN_FILE)
    {
      perror("descripteur de fichier incorrecte");
      return -1;
    }
  pdesc = desc_table + descripteur;
  pstat = pdesc->stat;
  buf->etat = pstat->etat;
  buf->type = pstat->type;
  buf->taille = pstat->taille;
  buf->liens = pstat->liens;
  return 0;
}

int link_minifs(char *src, char *dst)
{
  n_noeud_s num_node_src, num_node_dst, num_node_pere;
  int taille_dst;
  int rn;
  char *rep_pere;
  char *lien;
  DESC *pdesc;
  stat_p pstat;
  noeud_p np, np_pere;
  entrep_p e;
  n_bloc_s num_bloc;

  taille_dst = strlen(dst);
  num_node_src = find_ref(src);
  if(num_node_src.num == -1)
    {
      perror("src non existant");
      return -1;
    }
  else
    {
      np = (noeud_p) malloc (sizeof(noeud_s));
      rn = read_node(np, num_node_src);
      if(rn == -1)
	{
	  perror("erreur inconue");
	  free(np);
	  return -1;
	}
      if(np->type == REP)
	{
	  perror(" ln : lien direct interdit pour un repertoire");
	  free(np);
	  return -1;
	}
      num_node_dst = find_ref(dst);
      if(num_node_dst.num != -1)
	{
	  perror("le fichier destination deja existant");
	  free(np);
	  return -1;
	}
      /* Separe le nom du rep et celui du lien */
      taille_dst = strlen(dst);
      while(dst[taille_dst-1] != '/' && taille_dst>0)
	{
	  taille_dst--;
	}
      if(taille_dst == 1)
	{
	  rep_pere = "/";
	}
      else if(taille_dst == 0)
	{
	  rep_pere = ".";
	}
      else
	{
	  rep_pere = (char *) malloc(taille_dst);
	  strncpy(rep_pere, dst, taille_dst-1);
	  rep_pere[taille_dst-1] = '\0';
	}
      lien = dst + taille_dst;
      if(strlen(lien) > 29  || strlen(lien) == 0)
	{	
	  if (strlen(lien) > 29)
	    fprintf(stderr,"ln : %s nom de lien trop long",lien);
	  if (strlen(lien) == 0)
	    fprintf(stderr,"ln : %s nom de lien trop court",lien);
	  free(np);
	  if(taille_dst>1)
	    free(rep_pere);
	  return -1;
	}
      num_node_pere = find_ref(rep_pere);
      if(num_node_pere.num == -1)
	{
	  perror("repertoire pere inexistant");
	  free(np);
	  free(rep_pere);
	  return -1;
	}
      if (num_node_pere.dev != num_node_src.dev) 
	{
	  perror("Impossible de creer un lien vers un autre disque");
	  free(np);
	  free(rep_pere);
	  return -1;
	}
      e = (entrep_p) malloc(sizeof(entrep_s));
      strcpy(e->nom, lien);
      e->numero = num_node_src.num;
      if((np_pere = new_entry(num_node_pere, e)) == NULL)
	{
	  if(num_err == ERREUR_INCONNUE)
	    perror("erreur inconue");
	  else if(num_err == ENTREE_EXISTANTE)
	    perror("entree existant deja");
	  else if(num_err == PLUS_DE_BLOC_LIBRE)
	    perror("plus de bloc libre");
	  else
	    perror("type incorrecte");
	  free(e);
	  free(np);
	  free(rep_pere);
	  return -1; 
	}
      np->liens++;
      if (write_node(np,num_node_src) == -1) {
	free(np);
	free(rep_pere);
	free(e);
	return -1;
      }		
      pdesc = desc_table + desc_cur_dir;
      if(num_node_pere.num == pdesc->node && num_node_pere.dev == pdesc->dev)
	{ 
	  num_bloc = num_of_bloc_i(pdesc->cur_bloc,num_node_pere);
	  if(read_bloc(pdesc->buffer,num_bloc) == -1)
	    {
	      perror("erreur inconue");
	      np_pere->liens--;			
	      free(np);
	      free(rep_pere);
	      free(e);
	      return -1;
	    }
	  pstat = pdesc->stat;
	  pstat->liens = np_pere->liens;
	  pstat->taille = np_pere->taille;
	}
    }
  return 0;
}//fin de la fonction

/*supprimer le lien renvois 0 en cas de succes sinon -1*/
int unlink_minifs(char *src)
{
  n_noeud_s struct_node, struct_node_pere;
  int rnode;	
  entrep_p e;
  noeud_p np, np_pere;
  n_bloc_s num_bloc;
  DESC *pdesc;
  stat_p pstat;
  int taille_src;
  char *lien;
  char *rep_pere; 
	
  /* Interdiction de supprimer . et .. */
  if (strcmp(src,".") == 0 || strcmp(src,"..") == 0) 
    {
      fprintf(stderr,"Impossible de supprimer le lien %s\n",src);
      return -1;
    }
  struct_node = find_ref(src);
  if(struct_node.num == -1)
    {
      perror("src non existant unlink");
      return -1;
    }
  np = (noeud_p) malloc (sizeof(noeud_s));
  rnode = read_node(np, struct_node);
  if(rnode == -1)
    {
      perror("erreur inconue");
      free(np);
      return -1;
    }
	
  if(np->type == REP)
    {
      fprintf(stderr,"unlink : %s is directory", src);
      free(np);
      return -1;
    }
  /* Separe le nom du rep et celui du lien */
  taille_src = strlen(src);
  while(src[taille_src-1] != '/' && taille_src>0)
    {
      taille_src--;
    }
  if(taille_src == 1)
    {
      rep_pere = "/";
    }
  else if(taille_src == 0)
    {
      rep_pere = ".";
    }
  else
    {
      rep_pere = (char *) malloc(taille_src);
      strncpy(rep_pere, src, taille_src-1);
      rep_pere[taille_src-1] = '\0';
    }
  lien = src + taille_src;
  if(strlen(lien) > 29  || strlen(lien) == 0)
    {	
      if (strlen(lien) > 29)
	fprintf(stderr,"ln : %s nom de lien trop long",lien);
      if (strlen(lien) == 0)
	fprintf(stderr,"ln : %s nom de lien trop court",lien);
      free(np);
      if(taille_src>1)
	free(rep_pere);
      return -1;
    }
  /* Recherche du rep pere dans lequel on supp le lien */
  struct_node_pere = find_ref(rep_pere);
  if(struct_node_pere.num == -1)
    {
      perror("repertoire pere non existant");
      free(np);
      free(rep_pere);
      return -1;
    }
  /*recherche de l'entree et sa suppression*/ 
  e = (entrep_p) malloc(sizeof(entrep_s));
  e->numero = struct_node.num;
  strcpy(e->nom, lien);
  if((np_pere = supp_entry(struct_node_pere,e)) == NULL)
    {
      if(num_err == ERREUR_INCONNUE)
	perror("erreur inconue");
      else if(num_err == ENTREE_REPERTOIRE_INCONNUE)
	perror("erreur entree repertoire inconue");
      else
	perror("type incorrecte");
      free(np);
      free(rep_pere);
      free(e);
      return -1;
    }
  if (write_node(np_pere,struct_node_pere) == -1) {
    free(np);
    free(rep_pere);
    free(e);
    return -1;
  }	
  /* Si le rep pere est le rep courant on met son entree dans la table des desc a jour */
  pdesc = desc_table + desc_cur_dir;
  if(struct_node_pere.num == pdesc->node && struct_node_pere.dev == pdesc->dev)
    {
      num_bloc = num_of_bloc_i(pdesc->cur_bloc,struct_node_pere);
      if(read_bloc(pdesc->buffer,num_bloc) == -1)
	{
	  perror("erreur inconue");
	  np_pere->liens++;
	  write_node(np, struct_node);
	  new_entry(struct_node_pere, e);
			
	  free(np);
	  free(rep_pere);
	  free(e);
	  return -1;
	}
      pstat = pdesc->stat;
      pstat->liens = np_pere->liens;
      pstat->taille = np_pere->taille;
    }
  /* Decremente le nombre de liens du noeud et le supprime eventuellemnt*/	
  np->liens--;
  if (write_node(np,struct_node) == -1) {
    free(np);
    free(rep_pere);
    free(e);
    return -1;
  }	
  if (supp_node(struct_node) == -1) {
    switch(num_err) {
    case RESTE_DES_LIENS:
      break;
    default:
      fprintf(stderr,"Suppreesion du noeud echouee\n");
      free(np);
      free(rep_pere);
      free(e);
      return -1;
    }
  }

  free(np);
  free(rep_pere);
  free(e);
  return 0;		
}

/* Monte la racine du disque 'disque_unix' sur 'reference'.
   Retourne 0 en cas de succes ou -1 sinon.
   Genere des erreur de type ERREUR_INCONNUE ou DISQUE_ERRONE si la taille du fichier
   disque_unix ne correspond pas a la taille d'un disque minifs ou DISQUE_DEJA_MONTE
   si le disque disque_unix est deja monte ou PLUS_DE_DEV_LIBRE si la table de montage 
   est pleine ou REF_INCORRECTE si la taille de 'reference' est nulle ou > 29. */
int mount_minifs (char *reference, char *disque_unix) {
  struct stat *stat_p;
  DEV *dev_p;
  DESC *desc_p;
  int i;
  short num_dev=-1;
  char *ref,*nom_ref,*nom_rep;
  noeud_p np;
  entrep_s entree;
  n_noeud_s num_noeud;
  n_bloc_s num_bloc_buffer;

  stat_p = (struct stat*) malloc(sizeof(struct stat));
  if (stat(disque_unix,stat_p) == -1) {
    free(stat_p);
    perror("stat");
    num_err = ERREUR_INCONNUE;
    return -1;
  }
  /* Verification sommaire qu'il s'agit bien d'un disque */
  if (stat_p->st_size != (TAILLE_BLOC*(TAILLE_ZONE_DESCRIPTION+TAILLE_ZONE_NOEUDS
				       +TAILLE_ZONE_DONNEES))) {
    free(stat_p);
    fprintf(stderr,"Le disque %s n'est pas valide\n",disque_unix);
    num_err = DISQUE_ERRONE;
    return -1;
  }
  /* On verifie si le disque n'a pas deja ete monte */
  /* On profite aussi de la boucle for pour regarder si il reste
     de la place pour rajouter un peripherique a mount_table */
  for (i=MAX_MOUNT_DISK-1 ; i>=0 ; i--) {
    if (mount_table[i].dev == DEV_LIBRE && num_dev == -1) {
      num_dev = i;
    }
    else {
      if (mount_table[i].st_ino == stat_p->st_ino && mount_table[i].st_dev == stat_p->st_dev){
	/* Le disque est deja monte */
	free(stat_p);
	num_err = DISQUE_DEJA_MONTE;
	fprintf(stderr,"Le disque %s est deja monte\n",disque_unix);
	return -1;
      }
    }
  }
  if (num_dev == -1) { /* Il n'y a plus de place pour monter un nouveau peripherique */
    free(stat_p);
    num_err = PLUS_DE_DEV_LIBRE;
    fprintf(stderr,"Impossible de monter plus de %d disques\n",MAX_MOUNT_DISK);
    return -1;
  }
  /* On peut monter le disque */
  dev_p = mount_table + num_dev;
  dev_p->st_ino = stat_p->st_ino;
  dev_p->st_dev = stat_p->st_dev;
  if ((dev_p->desc=open(disque_unix,O_RDWR)) == -1) {
    num_err = ERREUR_INCONNUE;
    perror("open");
    return -1;
  }
  free(stat_p);
  /* On extrait de 'reference' le nom du repertoire */
  ref = strdup(reference);
  if ((nom_ref=strrchr(ref,'/')) == NULL) {
    nom_rep = ".";
    nom_ref = ref;
  }
  else if (nom_ref == ref) {
    nom_rep = "/";
    nom_ref = ref+1;
  }
  else {
    nom_ref[0] = '\0';
    nom_rep = ref;
    nom_ref ++;
  }
  if (strlen(nom_ref) == 0) {
    fprintf(stderr,"Nom de reference trop court\n");
    num_err = REF_INCORRECTE;
    close(dev_p->desc);
    return -1;
  }
  if (strlen(nom_ref) > 29) {
    fprintf(stderr,"Nom de reference ne doit pas avoir plus de 29 caracteres\n");
    num_err = REF_INCORRECTE;
    close(dev_p->desc);
    return -1;
  }
  dev_p->ref = nom_ref;
  dev_p->dev = num_dev;
  /* On lit sa table des noeuds libres */
  if (read_free_nodes_table(num_dev) == -1) {
    dev_p->dev = DEV_LIBRE;
    close(dev_p->desc);
    return -1;
  }
  /* On lit sa table des blocs libres */
  if (read_free_blocs_table(num_dev) == -1) {
    free(dev_p->free_nodes_table);
    dev_p->dev = DEV_LIBRE;
    close(dev_p->desc);
    return -1;
  }
  /* Ajout du disque dans un disque deja monte */
  num_noeud = find_ref(nom_rep);
  dev_p->pere = num_noeud;
  if (num_noeud.num == -1) {
    switch (num_err) {
    case CHEMIN_INCORRECT:
      fprintf(stderr,"%s est un chemin errone\n",nom_rep);
      break;
    case ENTREE_REPERTOIRE_INCONNUE:
      fprintf(stderr,"Le repertoire %s n'existe pas\n",nom_rep);
      break;
    }
    dev_p->dev = DEV_LIBRE;
    free(dev_p->free_nodes_table);
    close(dev_p->desc);
    return -1;
  }
  entree.numero = ROOT_NODE;
  entree.nom[0] = '\0';
  strcat(entree.nom,nom_ref);
  if ((np=new_entry(num_noeud,&entree)) == NULL) {
    switch (num_err) {
    case TYPE_INCORRECT:
      fprintf(stderr,"%s n'est pas un repertoire\n",nom_rep);
      break;
    case ENTREE_EXISTANTE:
      fprintf(stderr,"%s contient deja une entree %s\n",nom_rep,nom_ref);
      break;
    case PLUS_DE_BLOC_LIBRE:
      fprintf(stderr,"Plus d'espace sur le disque %i pour rajouter une entree\n",num_noeud.dev);
      break;
    }
    dev_p->dev = DEV_LIBRE;
    close(dev_p->desc);
    free(np);
    free(dev_p->free_nodes_table);
    return -1;
  }
  np->liens ++;
  if (write_node(np,num_noeud) == -1) {
    dev_p->dev = DEV_LIBRE;
    close(dev_p->desc);
    free(np);
    free(dev_p->free_nodes_table);
    return -1;
  }
  /* Mise a jour du desc du rep courant si c'est le rep dans lequel on a monte le disque */
  desc_p = desc_table + desc_cur_dir;
  if (desc_p->node == (dev_p->pere).num && desc_p->dev == (dev_p->pere).dev) {
    /* Sa taille */
    (desc_p->stat)->taille = np->taille;
    /* Son nombre de liens */
    (desc_p->stat)->liens = np->liens;   
    /* Son buffer */
    num_bloc_buffer = num_of_bloc_i(desc_p->cur_bloc,dev_p->pere);
    if (num_bloc_buffer.num == -1) {
      fprintf(stderr,"Erreur dans l'ajout de %s .",reference);
      fprintf(stderr,"Le rep courant est peut etre corrompu.\n");
    }
    if (read_bloc(desc_p->buffer,num_bloc_buffer) == -1) {
      fprintf(stderr,"Erreur dans l'ajout de %s .",reference);
      fprintf(stderr,"Le rep courant est peut etre corrompu.\n");
    }
  }

  free(np);
  return 0;
}

/* Demonte un disque monte sous le nom 'reference'.
   Retourne 0 en cas de succes ou -1 sinon.
   Genere des erreurs de type DISQUE_COURANT si on cherche a demonter le disque courant (ie
   sur lequel se trouve le rep courant, TYPE_INCORRECT et ENTREE_REPERTOIRE_INCONNUE si 
   la reference est un chemin invalide ou si le fichier n'existe pas, 
   RESTE_DES_DISQUES_MONTES si il reste des disques montes sur celui qu'on veut demonter
   ou DISQUE_INCONNU si reference designe un disque qui n'est pas ds la table de montage
   (ne devrait jamais se produire) */
int unmount_minifs (char *reference) {
  n_noeud_s num_noeud,num_noeud_pere;
  n_bloc_s num_bloc_buffer;
  DEV *dev_p;
  DESC *desc_p;
  noeud_p np;
  entrep_s entree;
  int i;

  /* On verifie que reference designe bien un disque monte */
  num_noeud = find_ref(reference);
  switch (num_noeud.num) {
  case ROOT_NODE:
    break;
  case -1:
    fprintf(stderr,"Demontage impossible: ");
    switch (num_err) {
    case CHEMIN_INCORRECT:
      fprintf(stderr,"%s est un chemin errone\n",reference);
      break;
    case ENTREE_REPERTOIRE_INCONNUE:
      fprintf(stderr,"Le repertoire %s n'existe pas\n",reference);
      break;
    }
    return -1;
  default:
    fprintf(stderr,"Demontage impossible: %s ne designe pas un disque monte\n",reference);
    num_err = DISQUE_INCONNU;
    return -1;
  }
  /* On verifie qu'aucun disque n'est encore monte sur le disque a demonter */
  for (i=0 ; i<MAX_MOUNT_DISK ; i++) {
    dev_p = mount_table + i;
    if (dev_p->pere.dev == num_noeud.dev) {
      fprintf(stderr,"Demontez les disques montes sur celui-ci pour le demonter");
      num_err = RESTE_DES_DISQUES_MONTES;
      return -1;
    }
  }
  /* On verifie si le rep courant n'est pas sur le disque a demonter */
  if (desc_table[desc_cur_dir].dev == num_noeud.dev) {
    fprintf(stderr,"Impossible de demonter le disque courant");
    num_err = DISQUE_COURANT;
    return -1;
  }
  /* Supression de l'entree dans le rep pere */
  dev_p = mount_table + num_noeud.dev;
  if (strcpy(entree.nom,dev_p->ref) == NULL) {
    perror("strcpy");
    num_err = ERREUR_INCONNUE;
    return -1;
  }
  entree.numero = num_noeud.num;
  if ((np=supp_entry(dev_p->pere,&entree)) == NULL) {
    if (num_err == TYPE_INCORRECT || num_err == ENTREE_REPERTOIRE_INCONNUE) {
      fprintf(stderr,"%s est un chemin invalide ou le fichier n'existe pas\n",reference);
    }
    return -1;
  }
  np->liens --;
  if (write_node(np,dev_p->pere) == -1) {
    free(np);
    return -1;
  }
  /* Si le rep dans lequel on supprime une entree est le rep courant,
     il faut mettre a jour son entree ds la table des descripteurs */
  desc_p = desc_table + desc_cur_dir;
  if (desc_p->node == (dev_p->pere).num && desc_p->dev == (dev_p->pere).dev) {
    num_noeud_pere.num = desc_p->node;
    num_noeud_pere.dev = desc_p->dev;
    /* Sa taille */
    (desc_p->stat)->taille = np->taille;
    /* Son nombre de liens */
    (desc_p->stat)->liens = np->liens;   
    /* Son buffer */
    num_bloc_buffer = num_of_bloc_i(desc_p->cur_bloc,num_noeud_pere);
    if (num_bloc_buffer.num == -1) {
      fprintf(stderr,"Erreur dans la supression de %s .",reference);
      fprintf(stderr,"Le rep courant est peut etre corrompu.\n");
    }
    if (read_bloc(desc_p->buffer,num_bloc_buffer) == -1) {
      fprintf(stderr,"Erreur dans la supression de %s .",reference);
      fprintf(stderr,"Le rep courant est peut etre corrompu.\n");
    }
  }
  free(np);
  /* Demontage */
  /* Derniere sauvegarde de la table des noeuds libres */
  if (write_free_nodes_table(num_noeud.dev) == -1) {
    fprintf(stderr,"Derniere sauvegarde de la table des noeuds libres impossible\n");
    /* On continue quand meme le demontage car normalement cette sauvegarde est inutile */
  }
  /* Derniere sauvegarde de la table des noeuds libres */
  if (write_free_blocs_table(num_noeud.dev) == -1) {
    fprintf(stderr,"Derniere sauvegarde de la table des noeuds libres impossible\n");
    /* On continue quand meme le demontage car normalement cette sauvegarde est inutile */
  }
  free(dev_p->free_nodes_table);
  if (close(dev_p->desc) == -1)
    perror("close");
  /* Liberation du dev */
  dev_p->dev = DEV_LIBRE;

  return 0;
}

int cause () 
{
  return num_err;
}
