#include <fcntl.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <fcntl.h>
#include <unistd.h>
#include "lib_minifs.h"

/* Cette fonction creer un nouveau disque minifs ayant pour nom celui passe en param */
int main (int argc, char* argv[]) {
  int desc;
  int i,reste;
  mode_t droits;
  void *buf_bloc;
  int *int_p;
  short *buf_tab;
  short *short_p;
  noeud_p node_p;
  noeud_s noeud;
  noeud_s noeud_racine;
  int num_bloc;
  entrep_s entree;
  entrep_p entree_p;

  if (argc != 2) {
    fprintf(stderr, "Specifiez en arg le nom du disque a creer\n");
    exit(EXIT_FAILURE);
  }
  /* Creation du fichier */
  droits = S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH;
  desc = open(argv[1],O_RDWR|O_CREAT|O_EXCL,droits);
  if (desc == -1) {
    fprintf(stderr, "Le fichier '%s' existe deja ou n'est pas un nom valide\n",argv[1]);
    exit(EXIT_FAILURE);
  }

  /* Remplissage */

  /* La zone de description */
  /* Table des noeuds libres */
  printf("MAX_FREE_NODES=%d\n",MAX_FREE_NODES);
  buf_tab = (short*) malloc(sizeof(short)*(MAX_FREE_NODES+1));
  for (i=0 ; i<MAX_FREE_NODES ; i++) {
    buf_tab[i] = i+1;
  }
  buf_tab[MAX_FREE_NODES] = 0;
  /* Caracteristique du disque */
  buf_bloc = realloc(buf_tab,TAILLE_BLOC);
  int_p = buf_bloc+(sizeof(short)*(MAX_FREE_NODES+1));
  *int_p = TAILLE_BLOC;
  int_p ++;
  *int_p = TAILLE_ZONE_DESCRIPTION;
  int_p ++;
  *int_p = TAILLE_ZONE_NOEUDS;
  int_p ++;
  *int_p = TAILLE_ZONE_DONNEES;
  /* Ecriture du 1er bloc */
  if (write(desc,buf_bloc,TAILLE_BLOC) != TAILLE_BLOC) {
    perror("write");
    free(buf_bloc);
    exit(EXIT_FAILURE);
  }
  
  /* La zone des noeuds */
  if (lseek(desc,TAILLE_ZONE_DESCRIPTION*TAILLE_BLOC,SEEK_SET) == -1) { 
    perror("lseek"); 
    free(buf_bloc); 
    exit(EXIT_FAILURE); 
  } 
  printf("zone de noeuds %d\n",(int)lseek(desc,(off_t)0,SEEK_CUR));
  /* Noeud correspondant a la racine */
  noeud_racine.etat = NOEUD_UTILISE;
  noeud_racine.type = REP;
  noeud_racine.liens = 2;
  noeud_racine.taille = sizeof(entrep_s)*2; /* . et .. */
  noeud_racine.blocs[0] = 0;  /* Le debut du rep racine se trouve sur le bloc 0 */
  for (i=1 ; i<12 ; i++) {
    noeud_racine.blocs[i] = TAILLE_ZONE_DONNEES; /* Valeur impossible */
  }
  /* Tous les autres noeuds sont vides */
  noeud.etat = NOEUD_LIBRE;
  noeud.type = REP;
  noeud.liens = 0;
  noeud.taille = 0;
  for (i=0 ; i<12 ; i++) {
    noeud.blocs[i] = TAILLE_ZONE_DONNEES; /* Valeur impossible */
  }
  /* Ecriture de tous les noeuds */
  for (num_bloc=0 ; num_bloc<TAILLE_ZONE_NOEUDS ; num_bloc++) {
    node_p = buf_bloc;
    for (i=0 ; i<NOEUDS_PAR_BLOC ; i++) {
      if (num_bloc == 0 && i == 0) 
	*node_p = noeud_racine;
      else
	*node_p = noeud;
      node_p ++;
    }
    if (write(desc,buf_bloc,TAILLE_BLOC) != TAILLE_BLOC) {
      perror("write");
      free(buf_bloc);
      exit(EXIT_FAILURE);
    }
  }

  /* La zone de donnees et 2eme bloc de la zone de description */
  /* Remplissage du bloc de la racine et mise a zero de tous les autres */
  printf("zone de donnees %d\n",(int)lseek(desc,(off_t)0,SEEK_CUR));
  free(buf_bloc);
  buf_bloc = calloc(TAILLE_BLOC,1);
  entree_p = (entrep_p)buf_bloc;
  /* La reference '.' */
  /*entree.nom[0] = '\0';*/
  strcpy(entree.nom,".");
  entree.numero = 0;
  *entree_p = entree;
  printf("(%s|%d)\n",(char*)entree_p->nom,entree_p->numero);
  entree_p ++;
  /* La reference '..' */
  strcpy(entree.nom,"..");
  entree.numero = 0;
  *entree_p = entree;
  printf("(%s|%d)\n",entree_p->nom,entree_p->numero);
  if (write(desc,buf_bloc,TAILLE_BLOC) != TAILLE_BLOC) {
    perror("write");
    free(buf_bloc);
    exit(EXIT_FAILURE);
  }
  free(buf_bloc);
  buf_bloc = calloc(TAILLE_BLOC,1);
  for (i=1 ; i<TAILLE_ZONE_DONNEES ; i++) {
    if (write(desc,buf_bloc,TAILLE_BLOC) != TAILLE_BLOC) {
      perror("write");
      free(buf_bloc);
      exit(EXIT_FAILURE);
    }
  }
  printf("fin de fichier %d\n",(int)lseek(desc,(off_t)0,SEEK_CUR));
  /* Table des blocs libres */ 
  /* Dans la zone de description (2eme bloc) */ 
  if (lseek(desc,TAILLE_BLOC,SEEK_SET) == -1) { 
    perror("lseek"); 
    free(buf_bloc); 
    exit(EXIT_FAILURE); 
  } 
  reste = (TAILLE_ZONE_DONNEES - 1)% MAX_FREE_BLOCS; 
  short_p = buf_bloc; 
  for (i=MAX_FREE_BLOCS-reste; i<MAX_FREE_BLOCS ; i++) { 
    short_p[i] = i+1-(MAX_FREE_BLOCS - reste); 
  } 
  short_p[MAX_FREE_BLOCS] = MAX_FREE_BLOCS - reste; 
  /* Dans la zone de donnes */ 
  for (i=reste ; i<TAILLE_ZONE_DONNEES ; i++) { 
    if (((i-reste)%MAX_FREE_BLOCS) == 0) { 
      if (i != reste) 
	*short_p = 0; 
      if (write(desc,buf_bloc,TAILLE_BLOC) != TAILLE_BLOC) { 
	perror("write"); 
	free(buf_bloc); 
	exit(EXIT_FAILURE); 
      }	 
      if (lseek(desc,DEBUTBLOC(i),SEEK_SET) == -1) { 
	perror("lseek"); 
	free(buf_bloc); 
	exit(EXIT_FAILURE); 
      }	 
      short_p = buf_bloc; 
    } 
    *short_p = i+1; 
    short_p++; 
  } 
  
  close(desc);
  free(buf_bloc);
  return EXIT_SUCCESS;
}
