#include "shell.h"

int main (int argc, char* argv[]) {
  char *ligne_comm;
  char **tabargs;
  int i;
  int val;

  printf("********************Bonjour****************************\n");
  /* Montage de la racine */
  if (mount_root("toto") == -1) {
    perror("#mount_root");
    exit(-1);
  }
  ligne_comm = (char *) malloc (TAILLE_LIGNE);
  /*******************
    Execution du shell.
  ********************/
  while (1)
    {
      printf("\n shell_minifs> ");
      /* On recupere la ligne de commande sur l'entree standard.
	 fgets recupere le '\n' et rajoute '\0' a la fin de la ligne.*/
      if((ligne_comm = fgets(ligne_comm, TAILLE_LIGNE + 1, stdin)) == NULL)
	{
	  printf("\n Erreur lors de la lecture sur l' entree standard ! \n");
	  exit(-1);
	}
      if ((tabargs = parseligne(ligne_comm)) == NULL)
	{
	  continue;
	}
      else
	{
	  i = 0;
	  while(tabargs[i] != NULL)
	    {
	      printf("Arg %d :  %s \n", i, tabargs[i]);
	      i++;
	    }
	  /******
	   sortie
	  *******/
	  if ((strcmp(tabargs[0], "exit") == 0))
	    {
	      /*Demontage RootDisk.
		On ne sort pas du shell, tant que tous les autres
		disques ne sont pas demontes.*/
	      if (unmount_root() == -1)
		{
		  affiche_cause(cause());
		  continue;
		}
	      /* On libere la memoire.*/
	      free(tabargs);
	      free(ligne_comm);
	      exit(0);
	    }
	  /*********************
	  Appel des fonctions.
	  **********************/
	  /* -2 : nombre d' arguments incorrect. */
	  /* -1 : erreur qcq precisee plus bas avec affiche_cause. */
	  if((strcmp(tabargs[0], "write") == 0))
	    {
	      if((val = write_mnfsh(tabargs)) == -2) 
		continue;
	    }
	  if((strcmp(tabargs[0], "mount") == 0))
	    {
	      if((val = mount_mnfsh(tabargs)) == -2) 
		continue;
	    }
	  if((strcmp(tabargs[0], "lsmount") == 0))
	    {
	      if((val = lsmount_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "unmount") == 0))
	    {
	      if((val = unmount_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "ls") == 0))
	    {
	      if((val = ls_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "cp") == 0))
	    {
	      if((val = cp_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "mkdir") == 0))
	    {
	      if((val = mkdir_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "rmdir") == 0))
	    {
	      if((val = rmdir_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "ln") == 0))
	    {
	      if((val = ln_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "rm") == 0))
	    {
	      if((val = rm_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "cat") == 0))
	    {
	      if((val = cat_mnfsh(tabargs)) == -2)
		continue;
	    }
	  if((strcmp(tabargs[0], "cd") == 0))
	    {
	      if((val = cd_mnfsh(tabargs)) == -2)
		continue;
	    }
	  /*********************************
	   Affichage d' eventuelles erreurs.
	  *********************************/
	  if(val == -1)
	    {
	      affiche_cause(cause());
	    }
	}
    }
  exit (-1);
}

/*************************************************************************
// Revoie un tableau, contenant toutes les sous chaines de la chaine 'ligne'
// separees par des espaces. ( ! 'ligne' doit se terminer par '\n')
// Renvoie NULL, si la chaine 'ligne' est vide ou NULL.
// *************************************************************************/
char **parseligne(char * ligne)
{
  char **sous_chaines;
  char *p_char1, *p_char2;
  int no_sschaine;
  int i;

  if((ligne == NULL) || (strlen(ligne) == 0)) 
    return NULL;
  else
    {
      sous_chaines = (char * *) malloc(NB_SOUSCHAINES * TAILLE_SOUSCHAINE);
      /* Initilisation du tableau; pour le cas ou il y a des espaces au debut
	 de la ligne.*/
      sous_chaines[0] = NULL;
      p_char1 = ligne;
      no_sschaine = 0;
      /* Parcours de la ligne jusqu' a '\n'*/
      while(*p_char1 != '\n')
	{
	  p_char2 = p_char1;
	  /* On passe les espaces ...*/
	  if(*p_char2 == ' ') 
	    {
	      p_char1++; 
	      continue;
	    }
	  i = 0;
	  sous_chaines[no_sschaine] = (char *) malloc(TAILLE_SOUSCHAINE);
	  /* On ajoute une sous chaine dans le tableau.*/
	  while(*p_char2 != ' ' && *p_char2 != '\n')
	    {
	      sous_chaines[no_sschaine][i] = *p_char2;
	      i++;
	      p_char2++;
	    }
	  sous_chaines[no_sschaine][i] = '\0';
	  no_sschaine++;
	  p_char1 = p_char2;
	}
    }
  if (sous_chaines[0] == NULL) return NULL;
  sous_chaines[no_sschaine] = NULL;

  return  sous_chaines;
}

/****************************************************************
// Renvoie le nombre de chaines, cotenu dans un tableau de chaines.
// (! la derniere case du tableau doit etre NULL)
// Renvoie -1, si le tableau est NULL.
// ****************************************************************/
int nb_chaines(char * *tabchaines)
{
  int cpt = 0;

  if (tabchaines == NULL)
    return -1;
  else 
    {
      while(tabchaines[cpt] != NULL)
	{
	  cpt++;
	}
    }
  return cpt;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int mkdir_mnfsh(char **args)
{
  if(nb_chaines(args) != 2 )
   {
     printf("\n Nombre d' arguments de la commande incorrect ! \n");
     return -2;
   }
  if (mkdir_minifs(args[1]) == -1)
   return -1;

  return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int rmdir_mnfsh(char * *args)
{
  if(nb_chaines(args) != 2)
   {
     printf("\n Nombre d' arguments de la commande incorrect ! \n");
     return -2;
   }

  if (rmdir_minifs(args[1]) == -1)
   return -1;

  return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int cd_mnfsh(char **args)
{
  desc_t d;
  
  if(nb_chaines(args) != 2 )
    {
      printf("\n Nombre d' arguments de la commande incorrect ! \n");
      return -2;
    }
  /* On ouvre le rep de destination */
  if ((d=open_minifs(args[1], M_LEC) )== -1) {
    switch (num_err) {
    case CHEMIN_INCORRECT:
      fprintf(stderr,"%s n'est pas un chemin valide\n", args[1]);
      return -1;
    case ENTREE_REPERTOIRE_INCONNUE:
      fprintf(stderr,"%s n'existe pas\n",args[1]);
      return -1;
    default:
      fprintf(stderr,"Erreur inconnue\n");
      return -1;
    }
  }
  /* On ferme le repertoire courant */
  if (close_minifs(desc_cur_dir) == -1) {
    fprintf(stderr,"Le repertoire courant a ete quitte incorrectement, des donnees ont\
                      peut etre ete perdue\n");
  }
  /* On change de repertoire courant */
  desc_cur_dir = d;

  return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int mount_mnfsh(char * *args)
{
if(nb_chaines(args) != 3)
   {
     printf("\n Nombre d' arguments de la commande incorrect ! \n");
     return -2;
   }

if (mount_minifs(args[1], args[2]) == -1)
   return -1;

return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int unmount_mnfsh(char * *args)
{
if(nb_chaines(args) != 2)
   {
     printf("\n Nombre d' arguments de la commande incorrect ! \n");
     return -2;
   }

if (unmount_minifs(args[1]) == -1)
   return -1;

return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int lsmount_mnfsh(char **args)
{
DEV *dev_p;
  int i;

  if(nb_chaines(args) >= 2)
   {
     printf("\n Nombre d' arguments de la commande incorrect ! \n");
     return -2;
   }

  for (i=0 ; i<MAX_MOUNT_DISK ; i++) {
    dev_p = mount_table + i;
    if (dev_p->dev != DEV_LIBRE) {
      printf("%s\n",dev_p->ref);
    }
  }

  return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int ls_mnfsh(char * *args)
{
  desc_t desc;
  int nb_args,option=0;
  stat_p status;
  struct entree_repertoire *entree;
  char* nom_fic;
  char* type;

  nb_args = nb_chaines(args);
  status = malloc(sizeof(struct status));
  /* On regarde si il y a l'option -l */
  if (nb_args != 1) {
    if (strcmp(args[1],"-l") == 0) {
      option ++;
    }
  }
  /* On verifie le nombre d'arg */
  if(nb_args > 2+option)
    {
      printf("\n Nombre d' arguments de la commande incorrect ! \n");
	  free(status);
      return -2;
    }
  /* Un nom de fichier ou de rep est passe en parametre ? */
  if (nb_args-option == 1) { /* Non */
    desc = desc_cur_dir;
    rewinddir_minifs(desc);
  }
  else { /* Un nom est specifie */
    if ((desc=open_minifs(args[1+option],M_LEC)) == -1) {
      fprintf(stderr,"Impossible d'ouvrir %s\n",args[1+option]);
	  free(status);
      return -1;
    }
    if (fstat_minifs(desc,status) == -1) {
      fprintf(stderr,"Impossible de connaitre les caract de %s\n",args[1+option]);
	  free(status);
      return -1;
    }
    /* On regarde s'il s'agit d'un fichier ou d'un rep */
    if (status->type == FIC) {
      /* On isole le nom du fichier */
      nom_fic = strrchr(args[1+option],'/');
      if (nom_fic == NULL)
	nom_fic = args[1+option];
      else
	nom_fic ++;
      /* Affiche les caracteristiques completes */
      printf("%s  fic  %d  %do\n",nom_fic,status->liens,status->taille);
	  free(status);
      return 0;
    }
  }
  /* Affiche les entrees du rep */
  entree = malloc(sizeof(entrep_s));
  while ((entree = readdir_minifs(desc)) != NULL) {
    if (option == 0) { /* Sans l'option -l */
      printf("%s\n",entree->nom);
    }
    else { /* Avec l'option -l */
      if (stat_minifs(entree->nom,status) == -1) {
	fprintf(stderr,"Impossible de connaitre les caract de %s\n",args[1+option]);
	free(entree);
	return -1;
      }
      if (status->type == FIC)
	type = "fic";
      else
	type = "rep";
      printf("%s  %s  %d lien(s)  %d octet(s)\n",entree->nom,type,status->liens,status->taille);
    }
  }
  free(entree);
  free(status);
  if (nb_args > 1+option) {
    if (close_minifs(desc) == -1) {
      fprintf(stderr,"Impossible de fermer %s\n",args[1+option]);
      return -1;
    }
  }
  return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int ln_mnfsh(char * *args)
{
   if(nb_chaines(args) != 3)
     {
       printf("\n Nombre d' arguments de la commande incorrect ! \n");
       return -2;
     }

   if(link_minifs(args[1], args[2]) == -1)
     return -1;

   return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int rm_mnfsh(char * *args)
{
   if(nb_chaines(args) != 2)
     {
       printf("\n Nombre d' arguments de la commande incorrect ! \n");
       return -2;
     }

   if(unlink_minifs(args[1]) == -1)
     return -1;

   return 0;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

int cp_mnfsh(char **args)
{
  stat_p st_src, st_dst, st_fic;
  int nb_args;
  desc_t d_src, d_dst, d_dst_fic, old_cur_dir, desc;
  entrep_p entree;
  char *nom_fic, *chemin;

  old_cur_dir = desc_cur_dir;
  nb_args = nb_chaines(args);
  if(nb_args != 3)
    {
      fprintf(stderr,"\n Nombre d' arguments de la commande incorrect ! \n");
      return -2;
    }
  /* On ouvre le fichier / rep de destination */
  if ((d_dst=open_minifs(args[2],M_CRE|M_ZER|M_ECR)) == -1) {
    fprintf(stderr,"Impossible d'ouvrir %s \n",args[2]);
    return -1;
  }
  st_dst = malloc(sizeof(struct status));
  if (fstat_minifs(d_dst,st_dst) == -1) {
    fprintf(stderr,"Impossible de lire les caracteristiques de %s \n",args[2]);
    close_minifs(d_dst);
    free(st_dst);
    return -1;
  }
  /* On ouvre le fichier / rep source */
  if ((d_src=open_minifs(args[1],M_LEC)) == -1) {
    fprintf(stderr,"Impossible d'ouvrir %s \n",args[2]);
    close_minifs(d_dst);
    free(st_dst);
    return -1;
  }
  st_src = malloc(sizeof(struct status));
  if (fstat_minifs(d_src,st_src) == -1) {
    fprintf(stderr,"Impossible de lire les caracteristiques de %s \n",args[2]);
    free(st_dst);
    close_minifs(d_src);
    close_minifs(d_dst);
    free(st_src);
    return -1;
  }
  /* On regarde si la ref de destination est un fichier */
  if (st_dst->type == FIC) { /* C'est un fichier */
    /* Dans ce cas la ref source doit designer un fichier */
    if (st_src->type != FIC) {
      fprintf(stderr,"Si la destination est un fichier alors le source est aussi un fichier\n");
      free(st_dst);
      close_minifs(d_src);
      close_minifs(d_dst);
      free(st_src);
      return -1;
    }
    /* Si c'est un fichier on copie le source dans la destination */
    if (cp_ficdansfic(d_dst,d_src,st_src->taille) == -1) {
      free(st_dst);
      close_minifs(d_src);
      close_minifs(d_dst);
      free(st_src);
      return -1;
    }
  }
  else { /* C'est un rep */
    /* Si la ref source est un fichier on la copie ds le rep */
    if (st_src->type == FIC) {
      /* On recupere le nom du fichier source */
      nom_fic = strrchr(args[1],'/');
      if (nom_fic == NULL)
	nom_fic = args[1];
      else 
	nom_fic ++;
      chemin = cree_chemin(args[2],nom_fic);
      /* Ouverture en troncature ou creation du fichier ds le rep de dest */
      if ((d_dst_fic=open_minifs(chemin,M_CRE|M_ZER|M_ECR)) == -1) {
	fprintf(stderr,"Impossible d'ouvrir / creer %s \n",chemin);
	free(st_dst);
	close_minifs(d_src);
	close_minifs(d_dst);
	free(st_src);
	free(chemin);
	return -1;
      }
      /* Recopie du source dans ce fichier */
      if (cp_ficdansfic(d_dst_fic,d_src,st_src->taille) == -1) {
	free(st_dst);
	close_minifs(d_src);
	close_minifs(d_dst_fic);
	close_minifs(d_dst);
	free(st_src);
	free(chemin);
	return -1;
      }
      if (close_minifs(d_dst_fic) == -1) {
	fprintf(stderr,"Impossible de fermer %s \n",chemin);
	free(st_dst);
	close_minifs(d_src);
	close_minifs(d_dst);
	free(st_src);
	free(chemin);
	return -1;
      }
      free(chemin);
    }
    else { /* Le source est un rep */
      /* On place temporairement le rep courant au niv du source */
      desc_cur_dir = d_src;
      /* On balaye toutes les entrees du rep */
      if (rewinddir_minifs(d_src) == -1) {
	fprintf(stderr,"Impossible de se mettre au debut de %s \
                    toutes les entrees ne seront peut etre pas copiees\n",args[1]);
	desc_cur_dir = old_cur_dir;
	free(st_dst);
	close_minifs(d_src);
	close_minifs(d_dst);
	free(st_src);
	return -1;
      }
      while ((entree=readdir_minifs(desc_cur_dir)) != NULL) {
	/* Ouverture des fichiers a copier */
	if ((desc=open_minifs(entree->nom,M_LEC)) == -1) {
	  fprintf(stderr,"Entree non copiee: %s \n",entree->nom);
	  desc_cur_dir = old_cur_dir;
	  free(st_dst);
	  close_minifs(d_src);
	  close_minifs(d_dst);
	  free(st_src);
	  return -1;
	}
	chemin = cree_chemin(args[2],entree->nom);
	if ((d_dst_fic=open_minifs(chemin,M_CRE|M_ZER|M_ECR)) == -1) {
	  fprintf(stderr,"Impossible d'ouvrir / creer %s \n",chemin);
	  free(st_dst);
	  desc_cur_dir = old_cur_dir;
	  close_minifs(d_src);
	  close_minifs(d_dst);
	  free(st_src);
	  free(chemin);
	  return -1;
	}
	/* Recuperation de la taille du fichier source */
	if (fstat_minifs(desc,st_fic) == -1) {
	  fprintf(stderr,"Impossible de lire les caracteristiques de %s \n",entree->nom);
	  desc_cur_dir = old_cur_dir;
	  free(st_dst);
	  close_minifs(desc);
	  close_minifs(d_src);
	  close_minifs(d_dst);
	  close_minifs(d_dst_fic);
	  free(st_src);
	  free(chemin);
	  return -1;
	}
	/* Copie des fichiers */
	if (cp_ficdansfic(d_dst_fic,desc,st_fic->taille) == -1) {
	  desc_cur_dir = old_cur_dir;
	  free(st_dst);
	  close_minifs(d_src);
	  close_minifs(desc);
	  close_minifs(d_dst);
	  close_minifs(d_dst_fic);
	  free(st_src);
	  free(chemin);
	  return -1;
	}
	/* Fermeture des fichiers copies */
	if (close_minifs(desc) == -1) {
	  fprintf(stderr,"Impossible de fermer %s \n",entree->nom);
	  free(st_dst);
	  desc_cur_dir = old_cur_dir;
	  close_minifs(d_src);
	  close_minifs(d_dst);
	  close_minifs(d_dst_fic);
	  free(st_src);
	  free(chemin);
	  return -1;
	}
	if (close_minifs(d_dst_fic) == -1) {
	  fprintf(stderr,"Impossible de fermer %s \n",chemin);
	  free(st_dst);
	  desc_cur_dir = old_cur_dir;
	  close_minifs(d_src);
	  close_minifs(d_dst);
	  free(st_src);
	  free(chemin);
	  return -1;
	}
	free(chemin);
      }
      free(entree);
    }
  }

  desc_cur_dir = old_cur_dir;
  free(st_dst);
  close_minifs(d_src);
  close_minifs(d_dst);
  free(st_src);
  return 0;
}

/* Copie un fichier dans un autre fichier. */
int cp_ficdansfic(desc_t d_dst, desc_t d_src, short taille)
{
  void *tampon;

  tampon = malloc(taille);
  if (read_minifs(d_src,tampon,taille) != taille) {
    free(tampon);
    fprintf(stderr,"Impossible de lire\n");
    return -1;
  }
  if (write_minifs(d_dst,tampon,taille) != taille) {
    free(tampon);
    fprintf(stderr,"Impossible de ecrire\n");
    return -1;
  }

  return 0;
}

/* Concatene deux chaines de caracteres pour en faire un chemin */
char * cree_chemin (char* rep, char* fic) {
  int taille_rep, taille_fic;
  int i=0;
  char *chemin;

  if (rep == NULL || fic == NULL)
    return NULL;
  taille_rep = strlen(rep);
  taille_fic = strlen(fic);
  if (strrchr(rep,'/') == rep+taille_rep-1){
    taille_rep --;
    rep[taille_rep] = '\0';
    i++;
  }
  chemin = malloc(taille_rep+taille_fic+2);
  strcpy(chemin,rep);
  strcat(chemin,"/");
  strcat(chemin,fic);
  if (i == 1)
    rep[taille_rep] = '/';

  return chemin;
}

/*                                  %%%%%%%%%%%%%%%%%%%%%*/

/* Syntaxe des arguments: write -o ref motif nb
   Ecrit dans le ficher 'ref' 'nb' fois le motif 'motif'.
   Avec l'option -f, l'ecriture se fait a la fin du fichier
   et avec -d au dbut.*/ 
/*mode = 0 pour classique et 1 pour o_append */
int write_mnfsh (char ** args) {
  char *tampon, *ref, *motif;
  char *char_p;
  int i,taille_motif, nb_motif, nb, mode, nb_args;
  desc_t desc;

  nb_args = nb_chaines(args);
  if (nb_args != 5)
     {
       printf("\n Nombre d' arguments de la commande incorrect ! \n");
       return -2;
     }
  if (strcmp("-d",args[1]) == 0)
    mode = 0;
  else if (strcmp("-f",args[1]) == 0)
    mode = 1;
  else {
    printf("\n Arguments de la commande incorrect ! \n");
    return -2;
  }
  ref = args[2];
  motif = args[3];
  nb = atoi(args[4]);
  nb_motif = nb;
  taille_motif = strlen(motif);
  /* on remplit le tampon avec la chaine qu'on veut ecrire */
  tampon = malloc(taille_motif*nb);
  char_p = tampon;
  while (nb>0) {
    for (i=0 ; i<taille_motif ; i++,char_p++) {
      *char_p = motif[i];
    }
    nb --;
  }
  /* Ouverture / creation du fichier a modifier */
  if ((desc=open_minifs(ref,M_ECR|M_CRE)) == -1) {
    fprintf(stderr,"Ouverture impossible de %s\n",ref);
    return -1;
  }
  /* Deplacement a la fin du fichier si ouverture en append */
  if (mode == 1) {
    if (lseek_minifs(desc,0,FIN) == -1) {
      fprintf(stderr,"Impossible de se deplacer a la fin de  %s\n",ref);
      return -1;
    }
  }
  /* On ecrit tampon dans le fichier */
  if (write_minifs(desc,tampon,taille_motif*nb_motif) == -1) {
    fprintf(stderr,"Ecriture impossible dans %s\n",ref);
    return -1;
  }
  /* On ferme le tampon */
  if (close_minifs(desc) == -1) {
    fprintf(stderr,"Fermeture impossible dans %s\n",ref);
    return -1;
  }

  free(tampon);
  return 0;
}

int cat_mnfsh(char **args)
{
  char *buf, *buf_vide;
  struct status st_ref;
  int nb_lu, nb_ecrit;
  desc_t dr;
  int val_stat;

  if(nb_chaines(args) != 2)
    {
      printf("\n Nombre d' arguments de la commande incorrect ! \n");
      return -2;
    }
  if ((val_stat = stat_minifs(args[1] ,&st_ref))==-1)
    {
      return -1;
    }
  if (st_ref.type == 1)
    {
      printf("\n cat impossible : le fichier  %s  est un repertoire.\n", args[1]);
      return(-1);
    }
  else
    {
      if ((dr =  open_minifs(args[1], M_LEC)) == -1)
	{
	  printf("\n Erreur lors de l' ouverture de %s ! \n", args[1]);
	  return (-1);
	}
      buf_vide = calloc(TAILLE_BUF_CAT,1);
      buf = calloc(TAILLE_BUF_CAT,1);
      while (( nb_lu = read_minifs(dr, buf, TAILLE_BUF_CAT)) >= 1)
	{
          if(( nb_ecrit =  fputs(buf, stdout)) == -1)
	    {
              printf("\n Erreur lors de l' ecriture sur la sortie standard ! \n");
	      free(buf);
	      free(buf_vide);
              return (-1);
            }
	  memcpy(buf,buf_vide,TAILLE_BUF_CAT);
        }
      if (nb_lu == -1)
	{
          printf("\n Erreur lors de la lecture dans %s ! \n", args[1]);
          close_minifs(dr);
	  free(buf);
	  free(buf_vide);
          return (-1);
        }
      if(close_minifs(dr) == -1)
	{
	  printf("\n Erreur lors de la fermeture de %s ! \n", args[1]);
	  free(buf);
	  free(buf_vide);
	  return -1;
	}
    }

  free(buf);
  free(buf_vide);
  return 0;
}

/********************************************************
 Affiche l'erreur correspondante a la valeur de cause().
*********************************************************/
int affiche_cause(int numero_err)
{
  if(numero_err < 0) return -1;
  switch (numero_err)
    {
    case ERREUR_INCONNUE :
      printf("erreur inconnue\n");
      break;
    case ENTREE_REPERTOIRE_INCONNUE :
      printf("entree repertoire inconue\n");
      break;
    case DISQUE_INCONNU :
      printf("disque inconnu\n");
      break;
    case DESCRIPTEUR_INCONNU:
      printf("descripteur inconnu\n");
      break;
    case MAUVAISE_POSITION :
      printf("mauvaise position\n");
      break;
    case PLUS_DE_NOEUD_LIBRE :
      printf("plus ed noeud libre\n");
      break;
    case PLUS_DE_BLOC_LIBRE :
      printf("plus de bloc libre\n");
      break;
    case TYPE_INCORRECT :
      printf("type incorrect\n");
      break;
    case CHEMIN_INCORRECT :
      printf("chemin incorrect\n");
      break;
    case RESTE_DES_LIENS :
      printf("reste des liens \n");
      break;
    case DISQUE_DEJA_MONTE :
      printf("disque deja monte\n");
      break;
    case DISQUE_ERRONE :
      printf("disque errone\n");
      break;
    case PLUS_DE_DEV_LIBRE:
      printf("plus de device libre\n");
      break;
    case ENTREE_EXISTANTE :
      printf("entree existante\n");
      break;
    case REF_INCORRECTE :
      printf("reference incorrect\n");
      break;
    case DISQUE_COURANT :
      printf("disque courant\n");
      break;
    case RESTE_DES_DISQUES_MONTES :
      printf("reste des disques montes\n");
      break;
    }

  return 0;
}

/* Monte le disque racine en initialisant les tables des descripteurs et de montage
   et en se placant dans le rep '/' comme rep courant. 
   Retourne -1 en cas d'echec et 0 sinon*/
int mount_root (char *disque_minifs) {
  struct stat *stat_p;
  DEV *dev_p;
  DESC *desc_p;
  int i;
  desc_t desc_root;
  
  /* Initialisation de la table de montage: toutes ses entrees sont declarees libres */
  for (i=0 ; i<MAX_MOUNT_DISK ; i++) {
    dev_p = mount_table + i;
    dev_p->dev = DEV_LIBRE;
  }
  /* Initialisation de la table des descripteurs: toutes ses entrees sont declarees libres */
  for (i=0 ; i<MAX_OPEN_FILE ; i++) {
    desc_p = desc_table + i;
    desc_p->desc = DESC_LIBRE;
  }
  /* Remplissage de la structure DEV de la racine */
  dev_p = mount_table;
  /* On memorise a quel fichier unix correspond la racine */
  stat_p = (struct stat*) malloc(sizeof(struct stat));
  if (stat(disque_minifs,stat_p) == -1) {
    free(stat_p);
    perror("stat");
    num_err = ERREUR_INCONNUE;
    return -1;
  }
  dev_p->st_ino = stat_p->st_ino;
  dev_p->st_dev = stat_p->st_dev;
  /* Verification sommaire qu'il s'agit bien d'un disque */
  if (stat_p->st_size != (TAILLE_BLOC*(TAILLE_ZONE_DESCRIPTION+TAILLE_ZONE_NOEUDS
				       +TAILLE_ZONE_DONNEES))) {
    free(stat_p);
    fprintf(stderr,"Le disque %s n'est pas valide\n",disque_minifs);
    num_err = DISQUE_ERRONE;
    return -1;
  }
  free(stat_p);
  /* Le nom de la racine est "/" */
  dev_p->ref = "/";
  /* Le rep pere de la racine est elle-meme */
  (dev_p->pere).num = ROOT_NODE;
  (dev_p->pere).dev = ROOT_DEV;
  /* Ouverture du fichier unix */
  if ((dev_p->desc=open(disque_minifs,O_RDWR)) == -1) {
    perror("open");
    num_err = ERREUR_INCONNUE;
    return -1;
  }
  /* La racine est montee */
  dev_p->dev = ROOT_DEV;
  /* On lit sa table des noeuds libres */
  if (read_free_nodes_table(ROOT_DEV) == -1) {
    dev_p->dev = DEV_LIBRE;
    return -1;
  }
  /* On lit sa table des blocs libres */
  if (read_free_blocs_table(ROOT_DEV) == -1) {
    free(dev_p->free_nodes_table);
    dev_p->dev = DEV_LIBRE;
    return -1;
  }
  
  /* Le systeme demarre au niv de la racine */
  if ((desc_root=open_minifs("/",M_LEC)) == -1) {
    free(dev_p->free_nodes_table);
    dev_p->dev = DEV_LIBRE;
    return -1;
  }
  desc_cur_dir = desc_root;

  return 0;
}

/* Demonte la racine s'il n'y a plus de disque monte. 
   Retourne 0 en cas de succes, -1 sinon */
int unmount_root ( ) {
  DEV *dev_p;
  int i;

  /* On verifie que tous les autres disque ont ete demontes */
  for (i=1 ; i<MAX_MOUNT_DISK ; i++) {
    if (mount_table[i].dev != DEV_LIBRE) {
      fprintf(stderr,"Demonter ts les disques avant de demonter le disque principal");
      return -1;
    }
  }
  /* Demontage du disque principal */
  dev_p = mount_table + ROOT_DEV;
  /* Derniere sauvegarde de la table des noeuds libres */
  if (write_free_nodes_table(ROOT_DEV) == -1) {
    fprintf(stderr,"Derniere sauvegarde de la table des noeuds libres impossible\n");
    /* On continue quand meme le demontage car normalement cette sauvegarde est inutile */
  }
  /* Derniere sauvegarde de la table des noeuds libres */
  if (write_free_blocs_table(ROOT_DEV) == -1) {
    fprintf(stderr,"Derniere sauvegarde de la table des noeuds libres impossible\n");
    /* On continue quand meme le demontage car normalement cette sauvegarde est inutile */
  }
  free(dev_p->free_nodes_table);
  if (close(dev_p->desc) == -1)
    perror("close");
  /* Liberation du dev */
  dev_p->dev = DEV_LIBRE;
  
  return 0;
}

